package com.fp.frontend.controller.armas.solicitud;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.parmas.soli.TarmDocumentoHabilitanteDetall;

/**
 * @author Carlos Guzman
 *
 */
@ManagedBean
@ViewScoped
public class DocumentoHabilitanteDetalleController extends AbstractController<TarmDocumentoHabilitanteDetall> {

    /**
     *
     */
    private static final long serialVersionUID = 8586936319898253550L;

    public DocumentoHabilitanteDetalleController() throws Exception {
        super(TarmDocumentoHabilitanteDetall.class);
    }

    @PostConstruct
    public void postConstruct() {
        this.init();
        super.startQuery();
    }

    private void init() {
        this.beanalias = "DOCUMENTOHABILITANTEDETAIL";
        this.recperpage = 15;
        this.lrecord = new ArrayList<>();
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            DtoQuery dto = super.getDtoQuery(Boolean.TRUE);

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(beanalias, dto); // permite adicionar mas de una tabla.

            Request request = callerhelper.getRequest();
            request.setQueryTables(mtables);

            Response resp = callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                lrecord = new ArrayList<>();
                MessageHelper.setMessageError(resp);
            } else {
                lrecord = (List<TarmDocumentoHabilitanteDetall>) resp.get(beanalias);
                super.postQuery(lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los registros nuevos.
            if (!dtosave.pendingProcess()) {
                return;
            }
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = callerhelper.getRequest();
            msave.put(beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Metodod que devuelve un documento habilitante detalle por el codigo de
     * documento
     *
     * @param codigoDocumento
     * @return
     */
    public static TarmDocumentoHabilitanteDetall findPorCodigoDocumento(String codigoDocumento) {
        try {
            DocumentoHabilitanteDetalleController cc = new DocumentoHabilitanteDetalleController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("cdocumento", codigoDocumento);
            cc.querydatabase();
            if (cc.record != null) {
                return cc.record;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    /**
     * Metodod que devuelve un documento habilitante detalle por el codigo de
     * documento
     *
     * @param codigoDocumento
     * @return
     */
    public static TarmDocumentoHabilitanteDetall findPorCDocumento(String cDocumento) {
        try {
            DocumentoHabilitanteDetalleController cc = new DocumentoHabilitanteDetalleController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("cdocumento", cDocumento);
            cc.querydatabase();
            if (cc.lrecord != null) {
                return cc.lrecord.get(0);
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    /**
     * Metodod que obtiene un documento habilitante por su codigo
     *
     * @param codigoSolicitud
     * @return
     */
    public static TarmDocumentoHabilitanteDetall findPorCodigo(String cdetalle) {
        try {
            DocumentoHabilitanteDetalleController cc = new DocumentoHabilitanteDetalleController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk", cdetalle);
            cc.querydatabase();
            if (cc.record != null) {
                return cc.record;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

}
